package org.foxarmy.barcodescannerforemployees.activities

import android.os.Bundle
import android.widget.Button
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import com.google.mlkit.vision.codescanner.GmsBarcodeScanning
import org.foxarmy.barcodescannerforemployees.DBStorageController
import org.foxarmy.barcodescannerforemployees.R
import org.foxarmy.barcodescannerforemployees.dataclasses.Product
import org.foxarmy.barcodescannerforemployees.views.AbstractProductView

class AddProductActivity : AppCompatActivity() {

    private lateinit var scanButton: Button
    private lateinit var abstractProductView: AbstractProductView

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        setContentView(R.layout.fragment_add_product)

        val extras = intent.extras
        val product = extras!!.get("product") as Product?


        scanButton = findViewById(R.id.scanButton)
        abstractProductView = findViewById(R.id.abstractProductView)
        /*
        scanButton = findViewById(R.id.scanButton)
        abstractProductView = AbstractProductView(this, this, AbstractProduct())
        findViewById<ConstraintLayout>(R.id.addProductConstraintLayout).addView(abstractProductView)
         */

        scanButton.setOnClickListener {
            val scanner = GmsBarcodeScanning.getClient(this)
            scanner.startScan()
                .addOnSuccessListener { barcode ->
                    findAndDisplayAbstractProductByBarcode(barcode.rawValue.toString())
                }
                .addOnFailureListener {
                    Toast.makeText(this, "Cannot scan barcode", Toast.LENGTH_SHORT).show()
                }
        }
    }

    fun findAndDisplayAbstractProductByBarcode(barcode: String) {
        val abstractProduct = DBStorageController(this).findAbstractProductByBarcode(DBStorageController(this).readableDatabase, barcode)
        if (abstractProduct == null) {
            Toast.makeText(this, "No product found", Toast.LENGTH_SHORT).show()
            return
        }
        abstractProductView.abstractProduct = abstractProduct
        abstractProductView.update()
    }
}